IMPLEMENTATION MODULE ResourceHandler;

FROM GEMAESbase  IMPORT
Outlined, Selected, Disabled, WorkXYWH, CurrXYWH;

FROM AESWindows  IMPORT
WindowGet;

FROM AESGraphics IMPORT
GrafMouseKeyboardState;

FROM AESForms    IMPORT
FormCenter;

FROM SYSTEM IMPORT 
ADDRESS, ADR, TSIZE;



PROCEDURE SetResourceAddress(VAR Res : ResourceType);
VAR 
  i, o : CARDINAL;
  a    : ADDRESS;
  Cptr : POINTER TO CARDINAL;
BEGIN
  (* relocate Tree indicies *)
  Cptr := Res.Header + ITree; o := Cptr^;
  IF (o > 0) THEN
    Cptr := Res.Header + RTree;
    Res.TreeAddr := Res.Header + ADDRESS(Cptr^);
    a := Res.TreeAddr;
    FOR i := 0 TO o-1 DO
      Res.TreeAddr^ := Res.TreeAddr^ + Res.Header; 
      Res.TreeAddr := ADDRESS(Res.TreeAddr) + 4; 
    END;
    Res.TreeAddr := a;
  END;
  (* relocate ted infos *)
  Cptr := Res.Header + ITedInfo; o := Cptr^;
  IF (o > 0) THEN
    Cptr := Res.Header + RTedInfo;
    Res.TedInfoAddr := Res.Header + ADDRESS(Cptr^);
    a := Res.TedInfoAddr;
    FOR i := 0 TO o-1 DO
      WITH Res.TedInfoAddr^ DO
        ptext  := ptext  + Res.Header;
        ptmplt := ptmplt + Res.Header;
        pvalid := pvalid + Res.Header;
        Res.TedInfoAddr := ADDRESS(Res.TedInfoAddr) + TEDINFOSIZE;
      END;
    END;
    Res.TedInfoAddr := a;
  END;
  (* relocate bit blocks *)
  Cptr := Res.Header + IBitBlk; o := Cptr^;
  IF (o > 0) THEN
    Cptr := Res.Header + RBitBlk;
    Res.BitBlkAddr := Res.Header + ADDRESS(Cptr^);
    a := Res.BitBlkAddr;
    FOR i := 0 TO o-1 DO
      Res.BitBlkAddr^.pdata := Res.BitBlkAddr^.pdata + Res.Header;
      Res.BitBlkAddr := ADDRESS(Res.BitBlkAddr) + BITBLKSIZE;
    END;
    Res.BitBlkAddr := a;
  END;
  (* relocate icon blocks *)
  Cptr := Res.Header + IIcon; o := Cptr^;
  IF (o > 0) THEN
    Cptr := Res.Header + RIcon;
    Res.IconBlkAddr := Res.Header + ADDRESS(Cptr^);
    a := Res.IconBlkAddr;
    FOR i := 0 TO o-1 DO
      WITH Res.IconBlkAddr^ DO
        pmask := pmask + Res.Header;
        pdata := pdata + Res.Header;
        ptext := ptext + Res.Header;
        Res.IconBlkAddr := ADDRESS(Res.IconBlkAddr) + ICONBLKSIZE;
      END;
    END;
    Res.IconBlkAddr := a;
  END;
  (* relocate object specs *)
  Cptr := Res.Header + IObject; o := Cptr^;
  IF (o > 0) THEN
    Cptr := Res.Header + RObject;
    Res.ObjectAddr := Res.Header + ADDRESS(Cptr^);
    a := Res.ObjectAddr;
    FOR i := 0 TO o-1 DO
      WITH Res.ObjectAddr^ DO
        IF (type # GBOX)  & (type # GPROGDEF) &
           (type # GIBOX) & (type # GBOXCHAR) THEN
          spec := spec + Res.Header;
        END;
     (*------------------------------------------------
        IF (this were a regular .RSC file) THEN 
          ResourceObjectFix(a,i); (* Fix the object! *)
        END
     ------------------------------------------------*)
        Res.ObjectAddr := ADDRESS(Res.ObjectAddr) + OBJECTSIZE;
      END;
    END;
    Res.ObjectAddr := a;
  END;
END SetResourceAddress;


PROCEDURE minusObj(Ob : ObjectPtr);
BEGIN
  WITH Ob^ DO
    IF ODD(state) THEN state := state - Selected END;
  END;
END minusObj;


PROCEDURE plusObj(Ob : ObjectPtr);
BEGIN
  WITH Ob^ DO
    IF ~ODD(state) THEN state := state + Selected END;
  END;
END plusObj;


PROCEDURE GetObject(tree : ADDRESS; index : INTEGER) : ObjectPtr;
BEGIN
  RETURN (tree + OBJECTSIZE * ADDRESS(index));
END GetObject;


PROCEDURE RelocPopUp(     tree             : ADDRESS; 
                          mousx,   mousy   : INTEGER;
                     VAR  cornerx, cornery : INTEGER);
VAR
  wx, wy, ww, wh   : INTEGER;
  ObjPtr           : ObjectPtr;

BEGIN
  WindowGet(0, WorkXYWH, wx, wy, ww, wh);
  ObjPtr := tree;
  WITH ObjPtr^ DO
    cornerx := mousx - (width + 1) DIV 2;
    IF (mousx - (width + 1) DIV 2 < wx) THEN
      cornerx := wx
    ELSIF (mousx + (width DIV 2) + 1 > wx + ww) THEN
      cornerx := (wx + ww) - width
    END;
    cornery := mousy - (height + 1) DIV 2;
    IF (mousy - (height + 1) DIV 2 < wy) THEN
      cornery := wy
    ELSIF (mousy + (height DIV 2) + 1 > wy + wh) THEN
      cornery := (wy + wh) - height
    END;
  END;
END RelocPopUp;


PROCEDURE XFormCenter(tree : ADDRESS; VAR cx, cy, cw, ch : INTEGER);
VAR
  X, Y, W, H : INTEGER;
  obptr      : POINTER TO OBJECT;
BEGIN
  WindowGet(0, CurrXYWH, X, Y, W, H);
  obptr := tree;
  IF (W DIV 4> obptr^.width) & (H DIV 4 > obptr^.height) THEN
    GrafMouseKeyboardState(X, Y, W, H);
    WITH obptr^ DO
      IF ODD(state DIV Outlined) THEN
        width  := width + 6; height := height + 6;
      END;
      RelocPopUp(tree, X, Y, x, y);
      cx := x;
      cy := y;
      cw := width;
      ch := height;
      IF ODD(state DIV Outlined) THEN
        x := x + 3;
        y := y + 3;
        width  := width - 6;
        height := height - 6;
      END;
    END;
  ELSE
    FormCenter(tree, cx, cy, cw, ch);
  END;
END XFormCenter;


END ResourceHandler.
